use strict;
use warnings;

use DBIx::Handler;

my $handler = DBIx::Handler->connect('dbi:mysql:dbname=myappdb', 'root', '', {
    RaiseError => 1,
});

$handler->txn(sub {
    my $dbh = shift;

    my $counter = $dbh->selectrow_hashref(q{
      SELECT * FROM counter
        WHERE id = ?
      LIMIT 1 FOR UPDATE
    }, undef,
        1, # id = ?
    );

    $dbh->do(q{
      UPDATE counter
        SET `count` = ?
      WHERE id = ?
    }, undef,
        $counter->{count} + 1, # count = ?
        $counter->{id},        # id = ?
    );
});
