use strict;
use warnings;

use DBI;
use DBIx::TransactionManager;

my $dbh = DBI->connect('dbi:mysql:dbname=myappdb', 'root', '', {
    RaiseError => 1,
});

my $txn_manager = DBIx::TransactionManager->new($dbh);

my $txn = $txn_manager->txn_scope();
eval {
    add_count();
    $txn->commit;
};
if (my $e = $@) {
    $txn->rollback;
    die $e;
}

sub add_count {
    my $txn = $txn_manager->txn_scope();
    eval {
        increment(1);
        $txn->commit;
    };
    if (my $e = $@) {
        $txn->rollback;
        die $e;
    }
}

sub increment {
    my ($id) = @_;

    my $txn = $txn_manager->txn_scope();
    my $count = eval {
        my $counter = $dbh->selectrow_hashref(q{
          SELECT * FROM counter
            WHERE id = ?
          LIMIT 1 FOR UPDATE
        }, undef,
            $id, # id = ?
        );

        $dbh->do(q{
          UPDATE counter
            SET `count` = ?
          WHERE id = ?
        }, undef,
            $counter->{count} + 1, # count = ?
            $counter->{id},        # id = ?
        );

        $txn->commit;
        $counter->{count} + 1;
    };
    if (my $e = $@) {
        $txn->rollback;
        die $e;
    }

    return $count;
}
