use strict;
use warnings;

use DBI;
use SQL::Maker;

my $dbh = DBI->connect('dbi:mysql:dbname=myappdb', 'root', '', {
    RaiseError => 1,
});

my $maker = SQL::Maker->new(driver => 'mysql');

$dbh->begin_work;

my $counter = do {
    my ($stmt, @bind) = $maker->select(counter => ['*'], {
        id => 1
    }, {
        for_update => 1,
    });
    $dbh->selectrow_hashref($stmt, undef, @bind);
};

do {
    my ($stmt, @bind) = $maker->update(counter => {
        count => $counter->{count} + 1,
    }, {
        id => $counter->{id},
    });
    $dbh->do($stmt, undef, @bind);
};

$dbh->commit;
