use strict;
use warnings;
use feature qw/say/;

use DBI;
use SQL::Maker;

warn "[HINT] try: perl $0 \$age" unless @ARGV;

my $age = shift @ARGV;

my $dbh = DBI->connect('dbi:mysql:dbname=myappdb', 'root', '', {
    RaiseError => 1,
});

my $maker = SQL::Maker->new(driver => 'mysql');

my $rows = do {
    my $select = $maker->new_select;
    $select->add_select('*')->add_from('employee');
    if ($age) {
        $select->add_where(age => $age);
    }

    my $sql = $select->as_sql;
    my @bind = $select->bind;
    $dbh->selectall_arrayref($sql, { Slice => {} }, @bind);
};

my @columns = qw/id name age sex/;
say join "\t", @columns;
for my $row (@$rows) {
    say join "\t", @$row{@columns};
}
