use strict;
use warnings;

use DBI;
use SQL::NamedPlaceholder qw/bind_named/;

my $dbh = DBI->connect('dbi:mysql:dbname=myappdb', 'root', '', {
    RaiseError => 1,
});

$dbh->begin_work;

my $counter = do {
    my ($stmt, $bind) = bind_named(q{
        SELECT * FROM counter WHERE id = :id LIMIT 1 FOR UPDATE
    }, {
        id => 1
    });
    $dbh->selectrow_hashref($stmt, undef, @$bind);
};

do {
    my ($stmt, $bind) = bind_named(q{
        UPDATE counter SET `count` = :count WHERE id = :id
    }, {
        count => $counter->{count} + 1,
        id    => $counter->{id},
    });
    $dbh->do($stmt, undef, @$bind);
};

$dbh->commit;
