package MyApp::DB::Schema;
use 5.014002;

use DBIx::Schema::DSL;
use Aniki::Schema::Relationship::Declare;

create_table country => columns {
    integer 'id', primary_key, auto_increment;
    varchar 'name', size => 32;
    varchar 'region', size => 32;
};

create_table city => columns {
    integer 'id', primary_key, auto_increment;
    varchar 'name', size => 32;
    integer 'country_id';

    belongs_to 'country';
};

create_table flight => columns {
    integer 'id', primary_key, auto_increment;
    varchar 'name', size => 32;
    integer 'departure_city_id';
    integer 'arrival_city_id';

    fk 'departure_city_id' => 'city', 'id';
    fk 'arrival_city_id'   => 'city', 'id';
};

1;
