use strict;
use warnings;

use FindBin;
use lib "$FindBin::Bin/lib";

use MyApp::DB;

my ($from, $to) = @ARGV;
die "Usage: $0 FromCity ToCity" unless $from && $to;

my $db = MyApp::DB->new(connect_info => ['dbi:mysql:dbname=myappdb', 'root', '', {
    RaiseError => 1
}]);

my $from_city = $db->select(city => { name => $from }, {
    limit => 1,
    prefetch => [qw/country departure_flights/],
})->first;
die "$from is not found on DB" unless $from_city;

my $to_city = $db->select(city => { name => $to }, {
    limit => 1,
    prefetch => [qw/country/],
})->first;
die "$to is not found on DB" unless $from_city;

printf q{====
FROM: %s (%s)
TO: %s (%s)
====
}, $from_city->name, $from_city->country->name
, $to_city->name, $to_city->country->name;

my ($flight) = grep { $_->arrival_city_id == $to_city->id } $from_city->departure_flights;
if ($flight) {
    printf "Found flight: %s $/", $flight->name;
} else {
    print "Not Found flight ...", $/;
}
