# O/Rマッパを利用したコードとそうでないコードの比較

実行しつつ、いろいろ改変して試してみましょう。

## ファイル構成

```
4 directories, 8 files
.
├── README.md
├── dbi.pl
├── dbic.pl
├── dump.pl
├── lib
│   └── MyApp
│       └── DB
│           ├── Schema
│           │   └── Result
│           │       └── Counter.pm
│           └── Schema.pm
└── schema.sql

5 directories, 7 files
```

- dbi.pl  - DBIを利用したインクリメント処理のコード
- dbic.pl - DBIx::Classを利用したインクリメント処理のコード
- dump.pl - データベースのカウンタを確認するスクリプト

## セットアップ

```bash
cpanm DBI DBD::mysql DBIx::Class
mysqladmin -uroot myappdb
mysql -uroot myappdb < schema.sql
```

## 実行

```
perl dbi.pl
perl dbic.pl
perl dump.pl
```
